﻿
Imports System.Data
Imports System.Data.SqlClient
Imports System.Web.Services
Imports System.Configuration
Partial Class VB
    Inherits System.Web.UI.Page
    Protected RepeatColumns As Integer
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Me.BindDummyItem()
        End If
    End Sub

    Private Sub BindDummyItem()
        Dim dummy As New DataTable()
        dummy.Columns.Add("ProductId")
        dummy.Columns.Add("Name")
        dummy.Columns.Add("Price")
        Dim count As Integer = If(dlProducts.RepeatColumns = 0, 1, dlProducts.RepeatColumns)
        For i As Integer = 0 To count - 1
            dummy.Rows.Add()
        Next
        dlProducts.DataSource = dummy
        dlProducts.DataBind()
        Me.RepeatColumns = IIf(dlProducts.RepeatColumns = 0, 1, dlProducts.RepeatColumns)
    End Sub

    <WebMethod()> _
    Public Shared Function GetProducts(start As Integer, [end] As Integer) As String
        System.Threading.Thread.Sleep(2000)
        Dim strConnString As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Dim ds As New DataSet()
        Using con As New SqlConnection(strConnString)
            Dim query As String = "SELECT * FROM Products WHERE (Price BETWEEN @Start AND @End) OR (@Start = 0 AND @End = 0)"
            Using cmd As New SqlCommand(query)
                cmd.Connection = con
                cmd.Parameters.AddWithValue("@Start", start)
                cmd.Parameters.AddWithValue("@End", [end])
                Using sda As New SqlDataAdapter(cmd)
                    sda.Fill(ds, "Products")
                End Using
            End Using
        End Using
        Dim dt As New DataTable()
        dt.TableName = "Range"
        Using con As New SqlConnection(strConnString)
            Dim query As String = "SELECT MIN(Price) [Min], MAX(Price) [Max] FROM Products"
            Using cmd As New SqlCommand(query)
                cmd.Connection = con
                Using sda As New SqlDataAdapter(cmd)
                    sda.Fill(dt)
                End Using
            End Using
        End Using
        ds.Tables.Add(dt)
        Return ds.GetXml()
    End Function
End Class
